## Description

This module will provide functionlity to track and report on changes to user entities.
The user entity changes are recorded in the database as a user_history entity that records 
the values of the user entity propoerties after any change (insert or update).  
If a user entity is deleted, then a history record is saved recording the deletion and the 
final values of the user entity properties.

The initial release will only record changes to the default properties of a user entity.
These are:
1. 'User id' => 'uid',
2. 'User name' => 'name',
3. 'User password' => 'pass',
4. 'User email' => 'mail',
5. 'User timezone' => 'timezone',
6. 'User status' => 'status',
7. 'User roles' => 'roles',
8. 'User created' => 'created',
9. 'User changed' => 'changed',
10. 'User access' => 'access',
11. 'user login' => 'login',
12. 'User init' => 'init',
13. 'User langcode' => 'langcode',
14. 'User preferred langcode' => 'preferred_langcode',
15. 'User preferred admin langcode' => 'preferred_admin_langcode',

User roles are obtained from the user account and recorded as an imploded string with "; " separator.

The properties "changed", "access", "login" are not particularly useful in tracking changes
to a user account as these values are updated automatically by Drupal during its normal
operation rather than as the result of an operator action.

The user history entities can be processed using the standard entity API functions,
except that there is no ability to manually add a new record, update an existing record
or delete one from the table.

Initial values for each existing user account are generated via a batch process after the module
has been installed.  Running this batch process is currently a manual task, but this may be chenged
to be automatic at some point in the future.

The user_history entities can be viewed using different view modes.  Two are provided by default
- a default mode which displays the full record
- a tab mode for display of key information from each change on a new tab of the user account page.

The user_history entities are fully compatible with views.  There are two default views provided 
with the module:
- a list of all user history records that can be filtered for records afeecting a specified user account,
  for changes within a date range, for changes involving a specified role, and for changes made by
  a specified user.
- a list of changes (rendered using the tab view mode) for a specified user account to be displayed
  on a new tab on the user account page.

User_history entities are rendered using the user_history twig template provided with the module, with a
small CSS file attached to ensure a consistent basic layout.  The template and attached CSS file
can be overridden by adding to a custom theme and modifying if required.

The module will keep any existing records for a user account which is deleted, and will add a new
record to record the deletion to ensure the history is retained.

## Usage
1. Install the module in the usual way.
2. Run the batch initialise process to create initial values for all existing user accounts.
   Go to "/user_history/initialise" or visit the status report and click on the link.


James Scott (jlscott)
07 Nov 2019
